<script setup lang="ts">
import type { Room } from '@/entities';
import { useFabriqueStore } from '@/stores/fabrique';
import { useRoomStore } from '@/stores/room';
import type { FormInstance } from 'element-plus';
import { storeToRefs } from 'pinia';
import { onMounted, ref, watch } from 'vue';
import { persistOrUpdate } from '../form-helpers'

const props = defineProps<{
    room?: Room
}>();
const emit = defineEmits(['cancel']);


const status = ref('');
const ruleFormRef = ref<FormInstance>()
const storeFabrique = useFabriqueStore();
const { fabriques, selected } = storeToRefs(storeFabrique);
const { persistRoom, updateRoom } = useRoomStore();

const initialValue = {
    name: '',
    capacity: 0,
    color: 'rgb(220,20,60)',
    fabrique: { ...selected.value }
}

const newRoom = ref<Room>({
    ...initialValue,
    ...props.room
});

async function handleForm() {
    await persistOrUpdate(newRoom.value, updateRoom, persistRoom);
    newRoom.value = {...initialValue};
}

onMounted(() => {
    storeFabrique.fetchFabriques();
})

watch(() => props.room, (value) => {

    if (value) {
        Object.assign(newRoom.value, value);
    } else {
        newRoom.value = {...initialValue};
    }
});



</script>


<template>
    <el-form ref="ruleFormRef" :model="newRoom" status-icon>
        <el-form-item label="Nom" prop="name">
            <el-input v-model="newRoom.name" />
        </el-form-item>
        <el-form-item label="Capacité" prop="capacity">
            <el-input type="number" v-model="newRoom.capacity" />
        </el-form-item>
        <el-form-item label="Fabrique" prop="fabrique">
            <el-select clearable filterable v-model="newRoom.fabrique" class="m-2"
                placeholder="Sélectionner la fabrique" size="large" value-key="id">
                <el-option v-for="fabrique in fabriques" :label="fabrique.name" :value="fabrique" />
            </el-select>
        </el-form-item>
        <el-form-item label="Couleur" prop="color">
            <el-color-picker v-model="newRoom.color" color-form="hex" show-alpha />
        </el-form-item>
        <el-form-item>
            <el-button type="primary" @click="handleForm()">
                <span v-if="newRoom.id">Modifier</span>
                <span v-if="!newRoom.id">Créer</span>
            </el-button>
            <el-button v-if="newRoom.id" type="info" @click="emit('cancel')">
                Annuler
            </el-button>
        </el-form-item>
    </el-form>

</template>